/* minefield.c generated by valac 0.24.0.61-c7ec, the Vala compiler
 * generated from minefield.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_FLAG_TYPE (flag_type_get_type ())

#define TYPE_LOCATION (location_get_type ())
#define LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOCATION, Location))
#define LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOCATION, LocationClass))
#define IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOCATION))
#define IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOCATION))
#define LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOCATION, LocationClass))

typedef struct _Location Location;
typedef struct _LocationClass LocationClass;
typedef struct _LocationPrivate LocationPrivate;
typedef struct _ParamSpecLocation ParamSpecLocation;

#define TYPE_NEIGHBOUR (neighbour_get_type ())
typedef struct _Neighbour Neighbour;

#define TYPE_MINEFIELD (minefield_get_type ())
#define MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINEFIELD, Minefield))
#define MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINEFIELD, MinefieldClass))
#define IS_MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINEFIELD))
#define IS_MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINEFIELD))
#define MINEFIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINEFIELD, MinefieldClass))

typedef struct _Minefield Minefield;
typedef struct _MinefieldClass MinefieldClass;
typedef struct _MinefieldPrivate MinefieldPrivate;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _location_unref0(var) ((var == NULL) ? NULL : (var = (location_unref (var), NULL)))
typedef struct _ParamSpecMinefield ParamSpecMinefield;

typedef enum  {
	FLAG_TYPE_NONE,
	FLAG_TYPE_FLAG,
	FLAG_TYPE_MAYBE
} FlagType;

struct _Location {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LocationPrivate * priv;
	gboolean has_mine;
	gboolean cleared;
	FlagType flag;
};

struct _LocationClass {
	GTypeClass parent_class;
	void (*finalize) (Location *self);
};

struct _ParamSpecLocation {
	GParamSpec parent_instance;
};

struct _Neighbour {
	gint x;
	gint y;
};

struct _Minefield {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MinefieldPrivate * priv;
	guint width;
	guint height;
	guint n_mines;
	gboolean exploded;
};

struct _MinefieldClass {
	GTypeClass parent_class;
	void (*finalize) (Minefield *self);
};

struct _MinefieldPrivate {
	Location** locations;
	gint locations_length1;
	gint locations_length2;
	gboolean placed_mines;
	guint _n_cleared;
	guint _n_flags;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};

struct _ParamSpecMinefield {
	GParamSpec parent_instance;
};


static gpointer location_parent_class = NULL;
static gpointer minefield_parent_class = NULL;

GType flag_type_get_type (void) G_GNUC_CONST;
gpointer location_ref (gpointer instance);
void location_unref (gpointer instance);
GParamSpec* param_spec_location (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_location (GValue* value, gpointer v_object);
void value_take_location (GValue* value, gpointer v_object);
gpointer value_get_location (const GValue* value);
GType location_get_type (void) G_GNUC_CONST;
enum  {
	LOCATION_DUMMY_PROPERTY
};
Location* location_new (void);
Location* location_construct (GType object_type);
static void location_finalize (Location* obj);
GType neighbour_get_type (void) G_GNUC_CONST;
Neighbour* neighbour_dup (const Neighbour* self);
void neighbour_free (Neighbour* self);
gpointer minefield_ref (gpointer instance);
void minefield_unref (gpointer instance);
GParamSpec* param_spec_minefield (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_minefield (GValue* value, gpointer v_object);
void value_take_minefield (GValue* value, gpointer v_object);
gpointer value_get_minefield (const GValue* value);
GType minefield_get_type (void) G_GNUC_CONST;
#define MINEFIELD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MINEFIELD, MinefieldPrivate))
enum  {
	MINEFIELD_DUMMY_PROPERTY
};
Minefield* minefield_new (guint width, guint height, guint n_mines);
Minefield* minefield_construct (GType object_type, guint width, guint height, guint n_mines);
gboolean minefield_is_clock_started (Minefield* self);
gdouble minefield_get_elapsed (Minefield* self);
gboolean minefield_has_mine (Minefield* self, guint x, guint y);
gboolean minefield_is_cleared (Minefield* self, guint x, guint y);
gboolean minefield_is_location (Minefield* self, gint x, gint y);
void minefield_clear_mine (Minefield* self, guint x, guint y);
static void minefield_start_clock (Minefield* self);
static void minefield_place_mines (Minefield* self, guint x, guint y);
static void minefield_clear_mines_recursive (Minefield* self, guint x, guint y);
static void minefield_stop_clock (Minefield* self);
gboolean minefield_get_is_complete (Minefield* self);
void minefield_set_flag (Minefield* self, guint x, guint y, FlagType flag);
guint minefield_get_n_cleared (Minefield* self);
void minefield_set_n_cleared (Minefield* self, guint value);
guint minefield_get_n_flags (Minefield* self);
void minefield_set_n_flags (Minefield* self, guint value);
guint minefield_get_n_adjacent_mines (Minefield* self, guint x, guint y);
FlagType minefield_get_flag (Minefield* self, guint x, guint y);
gboolean minefield_has_flag_warning (Minefield* self, guint x, guint y);
static gboolean minefield_timeout_cb (Minefield* self);
static void minefield_continue_clock (Minefield* self);
static gboolean _minefield_timeout_cb_gsource_func (gpointer self);
gboolean minefield_get_paused (Minefield* self);
void minefield_set_paused (Minefield* self, gboolean value);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void minefield_finalize (Minefield* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

const Neighbour neighbour_map[8] = {{-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}, {-1, 0}};

GType flag_type_get_type (void) {
	static volatile gsize flag_type_type_id__volatile = 0;
	if (g_once_init_enter (&flag_type_type_id__volatile)) {
		static const GEnumValue values[] = {{FLAG_TYPE_NONE, "FLAG_TYPE_NONE", "none"}, {FLAG_TYPE_FLAG, "FLAG_TYPE_FLAG", "flag"}, {FLAG_TYPE_MAYBE, "FLAG_TYPE_MAYBE", "maybe"}, {0, NULL, NULL}};
		GType flag_type_type_id;
		flag_type_type_id = g_enum_register_static ("FlagType", values);
		g_once_init_leave (&flag_type_type_id__volatile, flag_type_type_id);
	}
	return flag_type_type_id__volatile;
}


Location* location_construct (GType object_type) {
	Location* self = NULL;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self = (Location*) g_type_create_instance (object_type);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return self;
#line 198 "minefield.c"
}


Location* location_new (void) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return location_construct (TYPE_LOCATION);
#line 205 "minefield.c"
}


static void value_location_init (GValue* value) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	value->data[0].v_pointer = NULL;
#line 212 "minefield.c"
}


static void value_location_free_value (GValue* value) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (value->data[0].v_pointer) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		location_unref (value->data[0].v_pointer);
#line 221 "minefield.c"
	}
}


static void value_location_copy_value (const GValue* src_value, GValue* dest_value) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (src_value->data[0].v_pointer) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		dest_value->data[0].v_pointer = location_ref (src_value->data[0].v_pointer);
#line 231 "minefield.c"
	} else {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		dest_value->data[0].v_pointer = NULL;
#line 235 "minefield.c"
	}
}


static gpointer value_location_peek_pointer (const GValue* value) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return value->data[0].v_pointer;
#line 243 "minefield.c"
}


static gchar* value_location_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (collect_values[0].v_pointer) {
#line 250 "minefield.c"
		Location* object;
		object = collect_values[0].v_pointer;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		if (object->parent_instance.g_class == NULL) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 257 "minefield.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 261 "minefield.c"
		}
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = location_ref (object);
#line 265 "minefield.c"
	} else {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = NULL;
#line 269 "minefield.c"
	}
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return NULL;
#line 273 "minefield.c"
}


static gchar* value_location_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Location** object_p;
	object_p = collect_values[0].v_pointer;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!object_p) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 284 "minefield.c"
	}
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!value->data[0].v_pointer) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		*object_p = NULL;
#line 290 "minefield.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		*object_p = value->data[0].v_pointer;
#line 294 "minefield.c"
	} else {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		*object_p = location_ref (value->data[0].v_pointer);
#line 298 "minefield.c"
	}
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return NULL;
#line 302 "minefield.c"
}


GParamSpec* param_spec_location (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecLocation* spec;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LOCATION), NULL);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return G_PARAM_SPEC (spec);
#line 316 "minefield.c"
}


gpointer value_get_location (const GValue* value) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LOCATION), NULL);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return value->data[0].v_pointer;
#line 325 "minefield.c"
}


void value_set_location (GValue* value, gpointer v_object) {
	Location* old;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LOCATION));
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	old = value->data[0].v_pointer;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (v_object) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LOCATION));
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = v_object;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		location_ref (value->data[0].v_pointer);
#line 345 "minefield.c"
	} else {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = NULL;
#line 349 "minefield.c"
	}
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (old) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		location_unref (old);
#line 355 "minefield.c"
	}
}


void value_take_location (GValue* value, gpointer v_object) {
	Location* old;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LOCATION));
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	old = value->data[0].v_pointer;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (v_object) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LOCATION));
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = v_object;
#line 374 "minefield.c"
	} else {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = NULL;
#line 378 "minefield.c"
	}
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (old) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		location_unref (old);
#line 384 "minefield.c"
	}
}


static void location_class_init (LocationClass * klass) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	location_parent_class = g_type_class_peek_parent (klass);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	LOCATION_CLASS (klass)->finalize = location_finalize;
#line 394 "minefield.c"
}


static void location_instance_init (Location * self) {
#line 21 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->has_mine = FALSE;
#line 24 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->cleared = FALSE;
#line 27 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->flag = FLAG_TYPE_NONE;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->ref_count = 1;
#line 407 "minefield.c"
}


static void location_finalize (Location* obj) {
	Location * self;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOCATION, Location);
#line 415 "minefield.c"
}


GType location_get_type (void) {
	static volatile gsize location_type_id__volatile = 0;
	if (g_once_init_enter (&location_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_location_init, value_location_free_value, value_location_copy_value, value_location_peek_pointer, "p", value_location_collect_value, "p", value_location_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Location), 0, (GInstanceInitFunc) location_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType location_type_id;
		location_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Location", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&location_type_id__volatile, location_type_id);
	}
	return location_type_id__volatile;
}


gpointer location_ref (gpointer instance) {
	Location* self;
	self = instance;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_atomic_int_inc (&self->ref_count);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return instance;
#line 440 "minefield.c"
}


void location_unref (gpointer instance) {
	Location* self;
	self = instance;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		LOCATION_GET_CLASS (self)->finalize (self);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 453 "minefield.c"
	}
}


Neighbour* neighbour_dup (const Neighbour* self) {
	Neighbour* dup;
#line 31 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	dup = g_new0 (Neighbour, 1);
#line 31 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	memcpy (dup, self, sizeof (Neighbour));
#line 31 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return dup;
#line 466 "minefield.c"
}


void neighbour_free (Neighbour* self) {
#line 31 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_free (self);
#line 473 "minefield.c"
}


GType neighbour_get_type (void) {
	static volatile gsize neighbour_type_id__volatile = 0;
	if (g_once_init_enter (&neighbour_type_id__volatile)) {
		GType neighbour_type_id;
		neighbour_type_id = g_boxed_type_register_static ("Neighbour", (GBoxedCopyFunc) neighbour_dup, (GBoxedFreeFunc) neighbour_free);
		g_once_init_leave (&neighbour_type_id__volatile, neighbour_type_id);
	}
	return neighbour_type_id__volatile;
}


Minefield* minefield_construct (GType object_type, guint width, guint height, guint n_mines) {
	Minefield* self = NULL;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	Location** _tmp2_ = NULL;
	guint _tmp16_ = 0U;
	guint _tmp17_ = 0U;
	guint _tmp18_ = 0U;
#line 134 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self = (Minefield*) g_type_create_instance (object_type);
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = width;
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = height;
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = g_new0 (Location*, (_tmp0_ * _tmp1_) + 1);
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->locations = (_vala_array_free (self->priv->locations, self->priv->locations_length1 * self->priv->locations_length2, (GDestroyNotify) location_unref), NULL);
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->locations = _tmp2_;
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->locations_length1 = _tmp0_;
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->locations_length2 = _tmp1_;
#line 512 "minefield.c"
	{
		gint x = 0;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		x = 0;
#line 517 "minefield.c"
		{
			gboolean _tmp3_ = FALSE;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp3_ = TRUE;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			while (TRUE) {
#line 524 "minefield.c"
				gint _tmp5_ = 0;
				guint _tmp6_ = 0U;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (!_tmp3_) {
#line 529 "minefield.c"
					gint _tmp4_ = 0;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp4_ = x;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					x = _tmp4_ + 1;
#line 535 "minefield.c"
				}
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp3_ = FALSE;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp5_ = x;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp6_ = width;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (!(((guint) _tmp5_) < _tmp6_)) {
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					break;
#line 547 "minefield.c"
				}
				{
					gint y = 0;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					y = 0;
#line 553 "minefield.c"
					{
						gboolean _tmp7_ = FALSE;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp7_ = TRUE;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						while (TRUE) {
#line 560 "minefield.c"
							gint _tmp9_ = 0;
							guint _tmp10_ = 0U;
							Location** _tmp11_ = NULL;
							gint _tmp11__length1 = 0;
							gint _tmp11__length2 = 0;
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							Location* _tmp14_ = NULL;
							Location* _tmp15_ = NULL;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							if (!_tmp7_) {
#line 572 "minefield.c"
								gint _tmp8_ = 0;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp8_ = y;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								y = _tmp8_ + 1;
#line 578 "minefield.c"
							}
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp7_ = FALSE;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp9_ = y;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp10_ = height;
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							if (!(((guint) _tmp9_) < _tmp10_)) {
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								break;
#line 590 "minefield.c"
							}
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp11_ = self->priv->locations;
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp11__length1 = self->priv->locations_length1;
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp11__length2 = self->priv->locations_length2;
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp12_ = x;
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp13_ = y;
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp14_ = location_new ();
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_location_unref0 (_tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_]);
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_] = _tmp14_;
#line 139 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp15_ = _tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_];
#line 610 "minefield.c"
						}
					}
				}
			}
		}
	}
#line 140 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp16_ = width;
#line 140 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->width = _tmp16_;
#line 141 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp17_ = height;
#line 141 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->height = _tmp17_;
#line 142 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp18_ = n_mines;
#line 142 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->n_mines = _tmp18_;
#line 134 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return self;
#line 631 "minefield.c"
}


Minefield* minefield_new (guint width, guint height, guint n_mines) {
#line 134 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return minefield_construct (TYPE_MINEFIELD, width, height, n_mines);
#line 638 "minefield.c"
}


gboolean minefield_is_clock_started (Minefield* self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 145 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = minefield_get_elapsed (self);
#line 147 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 147 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp1_ > ((gdouble) 0);
#line 147 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 656 "minefield.c"
}


gboolean minefield_has_mine (Minefield* self, guint x, guint y) {
	gboolean result = FALSE;
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 150 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->locations;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->priv->locations_length1;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->priv->locations_length2;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->has_mine;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp4_;
#line 152 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 689 "minefield.c"
}


gboolean minefield_is_cleared (Minefield* self, guint x, guint y) {
	gboolean result = FALSE;
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 155 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->locations;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->priv->locations_length1;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->priv->locations_length2;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->cleared;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp4_;
#line 157 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 722 "minefield.c"
}


gboolean minefield_is_location (Minefield* self, gint x, gint y) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
#line 160 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = x;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp3_ >= 0) {
#line 738 "minefield.c"
		gint _tmp4_ = 0;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp4_ = y;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp2_ = _tmp4_ >= 0;
#line 744 "minefield.c"
	} else {
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp2_ = FALSE;
#line 748 "minefield.c"
	}
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp2_) {
#line 752 "minefield.c"
		gint _tmp5_ = 0;
		guint _tmp6_ = 0U;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp5_ = x;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp6_ = self->width;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp1_ = ((guint) _tmp5_) < _tmp6_;
#line 761 "minefield.c"
	} else {
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp1_ = FALSE;
#line 765 "minefield.c"
	}
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp1_) {
#line 769 "minefield.c"
		gint _tmp7_ = 0;
		guint _tmp8_ = 0U;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp7_ = y;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp8_ = self->height;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp0_ = ((guint) _tmp7_) < _tmp8_;
#line 778 "minefield.c"
	} else {
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp0_ = FALSE;
#line 782 "minefield.c"
	}
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 162 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 788 "minefield.c"
}


void minefield_clear_mine (Minefield* self, guint x, guint y) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	Location** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp4__length2 = 0;
	guint _tmp5_ = 0U;
	guint _tmp6_ = 0U;
	Location* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	guint _tmp14_ = 0U;
	guint _tmp15_ = 0U;
	Location** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	gint _tmp16__length2 = 0;
	guint _tmp17_ = 0U;
	guint _tmp18_ = 0U;
	Location* _tmp19_ = NULL;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
#line 165 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 167 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	minefield_start_clock (self);
#line 170 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->placed_mines;
#line 170 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!_tmp0_) {
#line 821 "minefield.c"
		guint _tmp1_ = 0U;
		guint _tmp2_ = 0U;
#line 172 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp1_ = x;
#line 172 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp2_ = y;
#line 172 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_place_mines (self, _tmp1_, _tmp2_);
#line 173 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		self->priv->placed_mines = TRUE;
#line 832 "minefield.c"
	}
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = self->priv->locations;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4__length1 = self->priv->locations_length1;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4__length2 = self->priv->locations_length2;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp5_ = x;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp6_ = y;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp8_ = _tmp7_->cleared;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp8_) {
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp3_ = TRUE;
#line 852 "minefield.c"
	} else {
		Location** _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		gint _tmp9__length2 = 0;
		guint _tmp10_ = 0U;
		guint _tmp11_ = 0U;
		Location* _tmp12_ = NULL;
		FlagType _tmp13_ = 0;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp9_ = self->priv->locations;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp9__length1 = self->priv->locations_length1;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp9__length2 = self->priv->locations_length2;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp10_ = x;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp11_ = y;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp13_ = _tmp12_->flag;
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp3_ = _tmp13_ == FLAG_TYPE_FLAG;
#line 877 "minefield.c"
	}
#line 176 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp3_) {
#line 177 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return;
#line 883 "minefield.c"
	}
#line 179 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp14_ = x;
#line 179 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp15_ = y;
#line 179 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	minefield_clear_mines_recursive (self, _tmp14_, _tmp15_);
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp16_ = self->priv->locations;
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp16__length1 = self->priv->locations_length1;
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp16__length2 = self->priv->locations_length2;
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp17_ = x;
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp18_ = y;
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp19_ = _tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_];
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp20_ = _tmp19_->has_mine;
#line 182 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp20_) {
#line 907 "minefield.c"
		gboolean _tmp21_ = FALSE;
#line 184 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp21_ = self->exploded;
#line 184 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		if (!_tmp21_) {
#line 186 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			self->exploded = TRUE;
#line 187 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			minefield_stop_clock (self);
#line 188 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			g_signal_emit_by_name (self, "explode");
#line 919 "minefield.c"
		}
#line 190 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return;
#line 923 "minefield.c"
	}
#line 194 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp22_ = minefield_get_is_complete (self);
#line 194 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp23_ = _tmp22_;
#line 194 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp23_) {
#line 196 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_stop_clock (self);
#line 933 "minefield.c"
		{
			gint tx = 0;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			tx = 0;
#line 938 "minefield.c"
			{
				gboolean _tmp24_ = FALSE;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp24_ = TRUE;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				while (TRUE) {
#line 945 "minefield.c"
					gint _tmp26_ = 0;
					guint _tmp27_ = 0U;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					if (!_tmp24_) {
#line 950 "minefield.c"
						gint _tmp25_ = 0;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp25_ = tx;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						tx = _tmp25_ + 1;
#line 956 "minefield.c"
					}
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp24_ = FALSE;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp26_ = tx;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp27_ = self->width;
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					if (!(((guint) _tmp26_) < _tmp27_)) {
#line 197 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						break;
#line 968 "minefield.c"
					}
					{
						gint ty = 0;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						ty = 0;
#line 974 "minefield.c"
						{
							gboolean _tmp28_ = FALSE;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							_tmp28_ = TRUE;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							while (TRUE) {
#line 981 "minefield.c"
								gint _tmp30_ = 0;
								guint _tmp31_ = 0U;
								gint _tmp32_ = 0;
								gint _tmp33_ = 0;
								gboolean _tmp34_ = FALSE;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								if (!_tmp28_) {
#line 989 "minefield.c"
									gint _tmp29_ = 0;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp29_ = ty;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									ty = _tmp29_ + 1;
#line 995 "minefield.c"
								}
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp28_ = FALSE;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp30_ = ty;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp31_ = self->height;
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								if (!(((guint) _tmp30_) < _tmp31_)) {
#line 198 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									break;
#line 1007 "minefield.c"
								}
#line 199 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp32_ = tx;
#line 199 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp33_ = ty;
#line 199 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp34_ = minefield_has_mine (self, (guint) _tmp32_, (guint) _tmp33_);
#line 199 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								if (_tmp34_) {
#line 1017 "minefield.c"
									gint _tmp35_ = 0;
									gint _tmp36_ = 0;
#line 200 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp35_ = tx;
#line 200 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp36_ = ty;
#line 200 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									minefield_set_flag (self, (guint) _tmp35_, (guint) _tmp36_, FLAG_TYPE_FLAG);
#line 1026 "minefield.c"
								}
							}
						}
					}
				}
			}
		}
#line 201 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_signal_emit_by_name (self, "cleared");
#line 1036 "minefield.c"
	}
}


static void minefield_clear_mines_recursive (Minefield* self, guint x, guint y) {
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	Location** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint _tmp5__length2 = 0;
	guint _tmp6_ = 0U;
	guint _tmp7_ = 0U;
	Location* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	guint _tmp10_ = 0U;
	Location** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	gint _tmp11__length2 = 0;
	guint _tmp12_ = 0U;
	guint _tmp13_ = 0U;
	Location* _tmp14_ = NULL;
	FlagType _tmp15_ = 0;
	Location** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	gint _tmp18__length2 = 0;
	guint _tmp19_ = 0U;
	guint _tmp20_ = 0U;
	Location* _tmp21_ = NULL;
	guint _tmp22_ = 0U;
	guint _tmp23_ = 0U;
	gboolean _tmp24_ = FALSE;
	Location** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	gint _tmp25__length2 = 0;
	guint _tmp26_ = 0U;
	guint _tmp27_ = 0U;
	Location* _tmp28_ = NULL;
	gboolean _tmp29_ = FALSE;
#line 205 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->locations;
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->priv->locations_length1;
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->priv->locations_length2;
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->cleared;
#line 208 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp4_) {
#line 209 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return;
#line 1100 "minefield.c"
	}
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp5_ = self->priv->locations;
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp5__length1 = self->priv->locations_length1;
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp5__length2 = self->priv->locations_length2;
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp6_ = x;
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp7_ = y;
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp8_ = _tmp5_[(_tmp6_ * _tmp5__length2) + _tmp7_];
#line 211 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp8_->cleared = TRUE;
#line 212 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp9_ = minefield_get_n_cleared (self);
#line 212 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp10_ = _tmp9_;
#line 212 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	minefield_set_n_cleared (self, _tmp10_ + 1);
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp11_ = self->priv->locations;
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp11__length1 = self->priv->locations_length1;
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp11__length2 = self->priv->locations_length2;
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp12_ = x;
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp13_ = y;
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp14_ = _tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_];
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp15_ = _tmp14_->flag;
#line 213 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp15_ == FLAG_TYPE_FLAG) {
#line 1138 "minefield.c"
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
#line 214 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp16_ = minefield_get_n_flags (self);
#line 214 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp17_ = _tmp16_;
#line 214 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_set_n_flags (self, _tmp17_ - 1);
#line 1147 "minefield.c"
	}
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp18_ = self->priv->locations;
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp18__length1 = self->priv->locations_length1;
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp18__length2 = self->priv->locations_length2;
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp19_ = x;
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp20_ = y;
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp21_ = _tmp18_[(_tmp19_ * _tmp18__length2) + _tmp20_];
#line 215 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp21_->flag = FLAG_TYPE_NONE;
#line 216 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp22_ = x;
#line 216 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp23_ = y;
#line 216 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "redraw-sector", _tmp22_, _tmp23_);
#line 217 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "marks-changed");
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp25_ = self->priv->locations;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp25__length1 = self->priv->locations_length1;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp25__length2 = self->priv->locations_length2;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp26_ = x;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp27_ = y;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp28_ = _tmp25_[(_tmp26_ * _tmp25__length2) + _tmp27_];
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp29_ = _tmp28_->has_mine;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!_tmp29_) {
#line 1187 "minefield.c"
		guint _tmp30_ = 0U;
		guint _tmp31_ = 0U;
		guint _tmp32_ = 0U;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp30_ = x;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp31_ = y;
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp32_ = minefield_get_n_adjacent_mines (self, _tmp30_, _tmp31_);
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp24_ = _tmp32_ == ((guint) 0);
#line 1199 "minefield.c"
	} else {
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp24_ = FALSE;
#line 1203 "minefield.c"
	}
#line 220 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp24_) {
#line 1207 "minefield.c"
		{
			Neighbour* neighbour_collection = NULL;
			gint neighbour_collection_length1 = 0;
			gint _neighbour_collection_size_ = 0;
			gint neighbour_it = 0;
#line 222 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			neighbour_collection = neighbour_map;
#line 222 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 222 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1219 "minefield.c"
				Neighbour neighbour = {0};
#line 222 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				neighbour = neighbour_collection[neighbour_it];
#line 1223 "minefield.c"
				{
					gint nx = 0;
					guint _tmp33_ = 0U;
					Neighbour _tmp34_ = {0};
					gint _tmp35_ = 0;
					gint ny = 0;
					guint _tmp36_ = 0U;
					Neighbour _tmp37_ = {0};
					gint _tmp38_ = 0;
					gint _tmp39_ = 0;
					gint _tmp40_ = 0;
					gboolean _tmp41_ = FALSE;
#line 224 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp33_ = x;
#line 224 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp34_ = neighbour;
#line 224 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp35_ = _tmp34_.x;
#line 224 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					nx = ((gint) _tmp33_) + _tmp35_;
#line 225 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp36_ = y;
#line 225 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp37_ = neighbour;
#line 225 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp38_ = _tmp37_.y;
#line 225 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					ny = ((gint) _tmp36_) + _tmp38_;
#line 226 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp39_ = nx;
#line 226 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp40_ = ny;
#line 226 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp41_ = minefield_is_location (self, _tmp39_, _tmp40_);
#line 226 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					if (_tmp41_) {
#line 1260 "minefield.c"
						gint _tmp42_ = 0;
						gint _tmp43_ = 0;
#line 227 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp42_ = nx;
#line 227 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp43_ = ny;
#line 227 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						minefield_clear_mines_recursive (self, (guint) _tmp42_, (guint) _tmp43_);
#line 1269 "minefield.c"
					}
				}
			}
		}
	}
}


void minefield_set_flag (Minefield* self, guint x, guint y, FlagType flag) {
	gboolean _tmp0_ = FALSE;
	Location** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gint _tmp1__length2 = 0;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	Location* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	FlagType _tmp12_ = 0;
	Location** _tmp22_ = NULL;
	gint _tmp22__length1 = 0;
	gint _tmp22__length2 = 0;
	guint _tmp23_ = 0U;
	guint _tmp24_ = 0U;
	Location* _tmp25_ = NULL;
	FlagType _tmp26_ = 0;
	guint _tmp27_ = 0U;
	guint _tmp28_ = 0U;
#line 232 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = self->priv->locations;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1__length1 = self->priv->locations_length1;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1__length2 = self->priv->locations_length2;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = x;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = y;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp1_[(_tmp2_ * _tmp1__length2) + _tmp3_];
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp5_ = _tmp4_->cleared;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp5_) {
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp0_ = TRUE;
#line 1317 "minefield.c"
	} else {
		Location** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		gint _tmp6__length2 = 0;
		guint _tmp7_ = 0U;
		guint _tmp8_ = 0U;
		Location* _tmp9_ = NULL;
		FlagType _tmp10_ = 0;
		FlagType _tmp11_ = 0;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp6_ = self->priv->locations;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp6__length1 = self->priv->locations_length1;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp6__length2 = self->priv->locations_length2;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp7_ = x;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp8_ = y;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp10_ = _tmp9_->flag;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp11_ = flag;
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp10_ == _tmp11_;
#line 1345 "minefield.c"
	}
#line 234 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp0_) {
#line 235 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return;
#line 1351 "minefield.c"
	}
#line 237 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp12_ = flag;
#line 237 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp12_ == FLAG_TYPE_FLAG) {
#line 1357 "minefield.c"
		guint _tmp13_ = 0U;
		guint _tmp14_ = 0U;
#line 238 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp13_ = minefield_get_n_flags (self);
#line 238 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp14_ = _tmp13_;
#line 238 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_set_n_flags (self, _tmp14_ + 1);
#line 1366 "minefield.c"
	} else {
		Location** _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		gint _tmp15__length2 = 0;
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
		Location* _tmp18_ = NULL;
		FlagType _tmp19_ = 0;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp15_ = self->priv->locations;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp15__length1 = self->priv->locations_length1;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp15__length2 = self->priv->locations_length2;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp16_ = x;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp17_ = y;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp18_ = _tmp15_[(_tmp16_ * _tmp15__length2) + _tmp17_];
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp19_ = _tmp18_->flag;
#line 239 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		if (_tmp19_ == FLAG_TYPE_FLAG) {
#line 1391 "minefield.c"
			guint _tmp20_ = 0U;
			guint _tmp21_ = 0U;
#line 240 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp20_ = minefield_get_n_flags (self);
#line 240 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp21_ = _tmp20_;
#line 240 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			minefield_set_n_flags (self, _tmp21_ - 1);
#line 1400 "minefield.c"
		}
	}
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp22_ = self->priv->locations;
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp22__length1 = self->priv->locations_length1;
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp22__length2 = self->priv->locations_length2;
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp23_ = x;
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp24_ = y;
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp25_ = _tmp22_[(_tmp23_ * _tmp22__length2) + _tmp24_];
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp26_ = flag;
#line 242 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp25_->flag = _tmp26_;
#line 243 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp27_ = x;
#line 243 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp28_ = y;
#line 243 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "redraw-sector", _tmp27_, _tmp28_);
#line 1425 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 247 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 247 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 247 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1437 "minefield.c"
			Neighbour neighbour = {0};
#line 247 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1441 "minefield.c"
			{
				gint nx = 0;
				guint _tmp29_ = 0U;
				Neighbour _tmp30_ = {0};
				gint _tmp31_ = 0;
				gint ny = 0;
				guint _tmp32_ = 0U;
				Neighbour _tmp33_ = {0};
				gint _tmp34_ = 0;
				gboolean _tmp35_ = FALSE;
				gint _tmp36_ = 0;
				gint _tmp37_ = 0;
				gboolean _tmp38_ = FALSE;
#line 249 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp29_ = x;
#line 249 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp30_ = neighbour;
#line 249 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp31_ = _tmp30_.x;
#line 249 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp29_) + _tmp31_;
#line 250 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp32_ = y;
#line 250 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp33_ = neighbour;
#line 250 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp34_ = _tmp33_.y;
#line 250 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp32_) + _tmp34_;
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp36_ = nx;
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp37_ = ny;
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp38_ = minefield_is_location (self, _tmp36_, _tmp37_);
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp38_) {
#line 1479 "minefield.c"
					gint _tmp39_ = 0;
					gint _tmp40_ = 0;
					gboolean _tmp41_ = FALSE;
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp39_ = nx;
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp40_ = ny;
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp41_ = minefield_is_cleared (self, (guint) _tmp39_, (guint) _tmp40_);
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp35_ = _tmp41_;
#line 1491 "minefield.c"
				} else {
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp35_ = FALSE;
#line 1495 "minefield.c"
				}
#line 251 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp35_) {
#line 1499 "minefield.c"
					gint _tmp42_ = 0;
					gint _tmp43_ = 0;
#line 252 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp42_ = nx;
#line 252 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp43_ = ny;
#line 252 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					g_signal_emit_by_name (self, "redraw-sector", (guint) _tmp42_, (guint) _tmp43_);
#line 1508 "minefield.c"
				}
			}
		}
	}
#line 255 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "marks-changed");
#line 1515 "minefield.c"
}


FlagType minefield_get_flag (Minefield* self, guint x, guint y) {
	FlagType result = 0;
	Location** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	Location* _tmp3_ = NULL;
	FlagType _tmp4_ = 0;
#line 258 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->locations;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length1 = self->priv->locations_length1;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0__length2 = self->priv->locations_length2;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = x;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = y;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = _tmp3_->flag;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp4_;
#line 260 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 1548 "minefield.c"
}


guint minefield_get_n_adjacent_mines (Minefield* self, guint x, guint y) {
	guint result = 0U;
	guint n = 0U;
#line 263 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 265 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	n = (guint) 0;
#line 1559 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 266 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 266 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 266 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1571 "minefield.c"
			Neighbour neighbour = {0};
#line 266 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1575 "minefield.c"
			{
				gint nx = 0;
				guint _tmp0_ = 0U;
				Neighbour _tmp1_ = {0};
				gint _tmp2_ = 0;
				gint ny = 0;
				guint _tmp3_ = 0U;
				Neighbour _tmp4_ = {0};
				gint _tmp5_ = 0;
				gboolean _tmp6_ = FALSE;
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
				gboolean _tmp9_ = FALSE;
#line 268 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp0_ = x;
#line 268 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp1_ = neighbour;
#line 268 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp2_ = _tmp1_.x;
#line 268 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp0_) + _tmp2_;
#line 269 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp3_ = y;
#line 269 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp4_ = neighbour;
#line 269 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp5_ = _tmp4_.y;
#line 269 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp3_) + _tmp5_;
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp7_ = nx;
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp8_ = ny;
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp9_ = minefield_is_location (self, _tmp7_, _tmp8_);
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp9_) {
#line 1613 "minefield.c"
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
					gboolean _tmp12_ = FALSE;
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp10_ = nx;
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp11_ = ny;
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp12_ = minefield_has_mine (self, (guint) _tmp10_, (guint) _tmp11_);
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp6_ = _tmp12_;
#line 1625 "minefield.c"
				} else {
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp6_ = FALSE;
#line 1629 "minefield.c"
				}
#line 270 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp6_) {
#line 1633 "minefield.c"
					guint _tmp13_ = 0U;
#line 271 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp13_ = n;
#line 271 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					n = _tmp13_ + 1;
#line 1639 "minefield.c"
				}
			}
		}
	}
#line 273 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = n;
#line 273 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 1648 "minefield.c"
}


gboolean minefield_has_flag_warning (Minefield* self, guint x, guint y) {
	gboolean result = FALSE;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint _tmp20_ = 0U;
	guint _tmp21_ = 0U;
#line 276 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 278 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = x;
#line 278 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = y;
#line 278 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = minefield_is_cleared (self, _tmp0_, _tmp1_);
#line 278 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!_tmp2_) {
#line 279 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		result = FALSE;
#line 279 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return result;
#line 1675 "minefield.c"
	}
#line 281 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	n_mines = (guint) 0;
#line 281 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	n_flags = (guint) 0;
#line 1681 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 282 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 282 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 282 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1693 "minefield.c"
			Neighbour neighbour = {0};
#line 282 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1697 "minefield.c"
			{
				gint nx = 0;
				guint _tmp3_ = 0U;
				Neighbour _tmp4_ = {0};
				gint _tmp5_ = 0;
				gint ny = 0;
				guint _tmp6_ = 0U;
				Neighbour _tmp7_ = {0};
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gboolean _tmp11_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gboolean _tmp14_ = FALSE;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				FlagType _tmp18_ = 0;
#line 284 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp3_ = x;
#line 284 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp4_ = neighbour;
#line 284 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp5_ = _tmp4_.x;
#line 284 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				nx = ((gint) _tmp3_) + _tmp5_;
#line 285 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp6_ = y;
#line 285 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp7_ = neighbour;
#line 285 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp8_ = _tmp7_.y;
#line 285 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				ny = ((gint) _tmp6_) + _tmp8_;
#line 286 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp9_ = nx;
#line 286 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp10_ = ny;
#line 286 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp11_ = minefield_is_location (self, _tmp9_, _tmp10_);
#line 286 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (!_tmp11_) {
#line 287 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					continue;
#line 1742 "minefield.c"
				}
#line 288 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp12_ = nx;
#line 288 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp13_ = ny;
#line 288 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp14_ = minefield_has_mine (self, (guint) _tmp12_, (guint) _tmp13_);
#line 288 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp14_) {
#line 1752 "minefield.c"
					guint _tmp15_ = 0U;
#line 289 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp15_ = n_mines;
#line 289 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					n_mines = _tmp15_ + 1;
#line 1758 "minefield.c"
				}
#line 290 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp16_ = nx;
#line 290 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp17_ = ny;
#line 290 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp18_ = minefield_get_flag (self, (guint) _tmp16_, (guint) _tmp17_);
#line 290 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp18_ == FLAG_TYPE_FLAG) {
#line 1768 "minefield.c"
					guint _tmp19_ = 0U;
#line 291 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp19_ = n_flags;
#line 291 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					n_flags = _tmp19_ + 1;
#line 1774 "minefield.c"
				}
			}
		}
	}
#line 294 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp20_ = n_flags;
#line 294 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp21_ = n_mines;
#line 294 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp20_ > _tmp21_;
#line 294 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 1787 "minefield.c"
}


static void minefield_place_mines (Minefield* self, guint x, guint y) {
#line 298 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 1794 "minefield.c"
	{
		gint n = 0;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		n = 0;
#line 1799 "minefield.c"
		{
			gboolean _tmp0_ = FALSE;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp0_ = TRUE;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			while (TRUE) {
#line 1806 "minefield.c"
				gint _tmp1_ = 0;
				guint _tmp2_ = 0U;
				gint32 rx = 0;
				guint _tmp3_ = 0U;
				gint32 _tmp4_ = 0;
				gint32 ry = 0;
				guint _tmp5_ = 0U;
				gint32 _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
				gint32 _tmp8_ = 0;
				guint _tmp9_ = 0U;
				Location** _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				gint _tmp12__length2 = 0;
				gint32 _tmp13_ = 0;
				gint32 _tmp14_ = 0;
				Location* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (!_tmp0_) {
#line 1827 "minefield.c"
				}
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp0_ = FALSE;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp1_ = n;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp2_ = self->n_mines;
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (!(((guint) _tmp1_) < _tmp2_)) {
#line 300 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					break;
#line 1839 "minefield.c"
				}
#line 302 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp3_ = self->width;
#line 302 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp4_ = g_random_int_range ((gint32) 0, (gint32) _tmp3_);
#line 302 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				rx = _tmp4_;
#line 303 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp5_ = self->height;
#line 303 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp6_ = g_random_int_range ((gint32) 0, (gint32) _tmp5_);
#line 303 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				ry = _tmp6_;
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp8_ = rx;
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp9_ = x;
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (((guint) _tmp8_) == _tmp9_) {
#line 1859 "minefield.c"
					gint32 _tmp10_ = 0;
					guint _tmp11_ = 0U;
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp10_ = ry;
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp11_ = y;
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp7_ = ((guint) _tmp10_) == _tmp11_;
#line 1868 "minefield.c"
				} else {
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp7_ = FALSE;
#line 1872 "minefield.c"
				}
#line 305 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (_tmp7_) {
#line 306 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					continue;
#line 1878 "minefield.c"
				}
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp12_ = self->priv->locations;
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp12__length1 = self->priv->locations_length1;
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp12__length2 = self->priv->locations_length2;
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp13_ = rx;
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp14_ = ry;
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp15_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp16_ = _tmp15_->has_mine;
#line 308 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				if (!_tmp16_) {
#line 1896 "minefield.c"
					gboolean adj_found = FALSE;
					gboolean _tmp26_ = FALSE;
#line 310 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					adj_found = FALSE;
#line 1901 "minefield.c"
					{
						Neighbour* neighbour_collection = NULL;
						gint neighbour_collection_length1 = 0;
						gint _neighbour_collection_size_ = 0;
						gint neighbour_it = 0;
#line 312 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						neighbour_collection = neighbour_map;
#line 312 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 312 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1913 "minefield.c"
							Neighbour neighbour = {0};
#line 312 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
							neighbour = neighbour_collection[neighbour_it];
#line 1917 "minefield.c"
							{
								gboolean _tmp17_ = FALSE;
								gint32 _tmp18_ = 0;
								guint _tmp19_ = 0U;
								Neighbour _tmp20_ = {0};
								gint _tmp21_ = 0;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp18_ = rx;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp19_ = x;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp20_ = neighbour;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								_tmp21_ = _tmp20_.x;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								if (((guint) _tmp18_) == (_tmp19_ + _tmp21_)) {
#line 1934 "minefield.c"
									gint32 _tmp22_ = 0;
									guint _tmp23_ = 0U;
									Neighbour _tmp24_ = {0};
									gint _tmp25_ = 0;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp22_ = ry;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp23_ = y;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp24_ = neighbour;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp25_ = _tmp24_.y;
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp17_ = ((guint) _tmp22_) == (_tmp23_ + _tmp25_);
#line 1949 "minefield.c"
								} else {
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									_tmp17_ = FALSE;
#line 1953 "minefield.c"
								}
#line 314 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
								if (_tmp17_) {
#line 316 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									adj_found = TRUE;
#line 317 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
									break;
#line 1961 "minefield.c"
								}
							}
						}
					}
#line 321 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					_tmp26_ = adj_found;
#line 321 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
					if (!_tmp26_) {
#line 1970 "minefield.c"
						Location** _tmp27_ = NULL;
						gint _tmp27__length1 = 0;
						gint _tmp27__length2 = 0;
						gint32 _tmp28_ = 0;
						gint32 _tmp29_ = 0;
						Location* _tmp30_ = NULL;
						gint _tmp31_ = 0;
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp27_ = self->priv->locations;
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp27__length1 = self->priv->locations_length1;
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp27__length2 = self->priv->locations_length2;
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp28_ = rx;
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp29_ = ry;
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp30_ = _tmp27_[(_tmp28_ * _tmp27__length2) + _tmp29_];
#line 323 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp30_->has_mine = TRUE;
#line 324 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						_tmp31_ = n;
#line 324 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
						n = _tmp31_ + 1;
#line 1996 "minefield.c"
					}
				}
			}
		}
	}
}


static void minefield_start_clock (Minefield* self) {
	GTimer* _tmp0_ = NULL;
#line 330 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 332 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 332 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 2013 "minefield.c"
		GTimer* _tmp1_ = NULL;
#line 333 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 333 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 333 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 2021 "minefield.c"
	}
#line 334 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "clock-started");
#line 335 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	minefield_timeout_cb (self);
#line 2027 "minefield.c"
}


static void minefield_stop_clock (Minefield* self) {
	GTimer* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GTimer* _tmp3_ = NULL;
#line 338 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 340 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 340 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 341 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return;
#line 2043 "minefield.c"
	}
#line 342 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = self->priv->clock_timeout;
#line 342 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 2049 "minefield.c"
		guint _tmp2_ = 0U;
#line 343 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp2_ = self->priv->clock_timeout;
#line 343 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_source_remove (_tmp2_);
#line 2055 "minefield.c"
	}
#line 344 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 345 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = self->priv->clock;
#line 345 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_timer_stop (_tmp3_);
#line 346 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "tick");
#line 2065 "minefield.c"
}


static void minefield_continue_clock (Minefield* self) {
	GTimer* _tmp0_ = NULL;
#line 349 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 351 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 351 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 2077 "minefield.c"
		GTimer* _tmp1_ = NULL;
#line 352 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 352 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 352 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 2085 "minefield.c"
	} else {
		GTimer* _tmp2_ = NULL;
#line 354 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 354 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_timer_continue (_tmp2_);
#line 2092 "minefield.c"
	}
#line 355 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	minefield_timeout_cb (self);
#line 2096 "minefield.c"
}


static gboolean _minefield_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = minefield_timeout_cb ((Minefield*) self);
#line 364 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2105 "minefield.c"
}


static gboolean minefield_timeout_cb (Minefield* self) {
	gboolean result = FALSE;
	gdouble elapsed = 0.0;
	GTimer* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gint next = 0;
	gdouble wait = 0.0;
	guint _tmp2_ = 0U;
#line 358 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 361 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 361 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = g_timer_elapsed (_tmp0_, NULL);
#line 361 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	elapsed = _tmp1_;
#line 362 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	next = (gint) (elapsed + 1.0);
#line 363 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	wait = next - elapsed;
#line 364 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((gint) (wait * 1000)), _minefield_timeout_cb_gsource_func, minefield_ref (self), minefield_unref);
#line 364 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->clock_timeout = _tmp2_;
#line 366 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "tick");
#line 368 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = FALSE;
#line 368 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2139 "minefield.c"
}


guint minefield_get_n_cleared (Minefield* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 72 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 72 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->_n_cleared;
#line 72 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 72 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2154 "minefield.c"
}


void minefield_set_n_cleared (Minefield* self, guint value) {
	guint _tmp0_ = 0U;
#line 73 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 73 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = value;
#line 73 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->_n_cleared = _tmp0_;
#line 2166 "minefield.c"
}


gboolean minefield_get_is_complete (Minefield* self) {
	gboolean result;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	guint _tmp4_ = 0U;
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = minefield_get_n_cleared (self);
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = self->width;
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = self->height;
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = self->n_mines;
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp1_ == ((_tmp2_ * _tmp3_) - _tmp4_);
#line 78 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2193 "minefield.c"
}


guint minefield_get_n_flags (Minefield* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 83 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 83 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->_n_flags;
#line 83 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 83 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2208 "minefield.c"
}


void minefield_set_n_flags (Minefield* self, guint value) {
	guint _tmp0_ = 0U;
#line 84 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 84 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = value;
#line 84 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->_n_flags = _tmp0_;
#line 2220 "minefield.c"
}


gdouble minefield_get_elapsed (Minefield* self) {
	gdouble result;
	GTimer* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	GTimer* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
#line 94 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 96 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 96 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 97 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		result = 0.0;
#line 97 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return result;
#line 2240 "minefield.c"
	}
#line 98 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = self->priv->clock_elapsed;
#line 98 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = self->priv->clock;
#line 98 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
#line 98 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp1_ + _tmp3_;
#line 98 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2252 "minefield.c"
}


gboolean minefield_get_paused (Minefield* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 121 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp0_ = self->priv->_paused;
#line 121 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	result = _tmp0_;
#line 121 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return result;
#line 2267 "minefield.c"
}


void minefield_set_paused (Minefield* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GTimer* _tmp4_ = NULL;
	gboolean _tmp11_ = FALSE;
#line 105 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp1_ = minefield_get_is_complete (self);
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp2_ = _tmp1_;
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp2_) {
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp0_ = TRUE;
#line 2287 "minefield.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp3_ = self->exploded;
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp0_ = _tmp3_;
#line 2294 "minefield.c"
	}
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp0_) {
#line 108 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return;
#line 2300 "minefield.c"
	}
#line 110 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp4_ = self->priv->clock;
#line 110 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (_tmp4_ != NULL) {
#line 2306 "minefield.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		_tmp6_ = value;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		if (_tmp6_) {
#line 2313 "minefield.c"
			gboolean _tmp7_ = FALSE;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp7_ = self->priv->_paused;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp5_ = !_tmp7_;
#line 2319 "minefield.c"
		} else {
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp5_ = FALSE;
#line 2323 "minefield.c"
		}
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		if (_tmp5_) {
#line 113 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			minefield_stop_clock (self);
#line 2329 "minefield.c"
		} else {
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
#line 114 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			_tmp9_ = value;
#line 114 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			if (!_tmp9_) {
#line 2337 "minefield.c"
				gboolean _tmp10_ = FALSE;
#line 114 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp10_ = self->priv->_paused;
#line 114 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp8_ = _tmp10_;
#line 2343 "minefield.c"
			} else {
#line 114 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				_tmp8_ = FALSE;
#line 2347 "minefield.c"
			}
#line 114 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			if (_tmp8_) {
#line 115 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
				minefield_continue_clock (self);
#line 2353 "minefield.c"
			}
		}
	}
#line 118 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_tmp11_ = value;
#line 118 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->_paused = _tmp11_;
#line 119 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_emit_by_name (self, "paused-changed");
#line 2363 "minefield.c"
}


static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (n_param_values == 3);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		data1 = closure->data;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		data2 = param_values->data[0].v_pointer;
#line 2382 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		data1 = param_values->data[0].v_pointer;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		data2 = closure->data;
#line 2388 "minefield.c"
	}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 2394 "minefield.c"
}


static void value_minefield_init (GValue* value) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	value->data[0].v_pointer = NULL;
#line 2401 "minefield.c"
}


static void value_minefield_free_value (GValue* value) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (value->data[0].v_pointer) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_unref (value->data[0].v_pointer);
#line 2410 "minefield.c"
	}
}


static void value_minefield_copy_value (const GValue* src_value, GValue* dest_value) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (src_value->data[0].v_pointer) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		dest_value->data[0].v_pointer = minefield_ref (src_value->data[0].v_pointer);
#line 2420 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2424 "minefield.c"
	}
}


static gpointer value_minefield_peek_pointer (const GValue* value) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return value->data[0].v_pointer;
#line 2432 "minefield.c"
}


static gchar* value_minefield_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (collect_values[0].v_pointer) {
#line 2439 "minefield.c"
		Minefield* object;
		object = collect_values[0].v_pointer;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		if (object->parent_instance.g_class == NULL) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2446 "minefield.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2450 "minefield.c"
		}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = minefield_ref (object);
#line 2454 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = NULL;
#line 2458 "minefield.c"
	}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return NULL;
#line 2462 "minefield.c"
}


static gchar* value_minefield_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Minefield** object_p;
	object_p = collect_values[0].v_pointer;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!object_p) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2473 "minefield.c"
	}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (!value->data[0].v_pointer) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		*object_p = NULL;
#line 2479 "minefield.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		*object_p = value->data[0].v_pointer;
#line 2483 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		*object_p = minefield_ref (value->data[0].v_pointer);
#line 2487 "minefield.c"
	}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return NULL;
#line 2491 "minefield.c"
}


GParamSpec* param_spec_minefield (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecMinefield* spec;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MINEFIELD), NULL);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return G_PARAM_SPEC (spec);
#line 2505 "minefield.c"
}


gpointer value_get_minefield (const GValue* value) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MINEFIELD), NULL);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return value->data[0].v_pointer;
#line 2514 "minefield.c"
}


void value_set_minefield (GValue* value, gpointer v_object) {
	Minefield* old;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MINEFIELD));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	old = value->data[0].v_pointer;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (v_object) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MINEFIELD));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = v_object;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_ref (value->data[0].v_pointer);
#line 2534 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = NULL;
#line 2538 "minefield.c"
	}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (old) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_unref (old);
#line 2544 "minefield.c"
	}
}


void value_take_minefield (GValue* value, gpointer v_object) {
	Minefield* old;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MINEFIELD));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	old = value->data[0].v_pointer;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (v_object) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MINEFIELD));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = v_object;
#line 2563 "minefield.c"
	} else {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		value->data[0].v_pointer = NULL;
#line 2567 "minefield.c"
	}
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (old) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		minefield_unref (old);
#line 2573 "minefield.c"
	}
}


static void minefield_class_init (MinefieldClass * klass) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	minefield_parent_class = g_type_class_peek_parent (klass);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	MINEFIELD_CLASS (klass)->finalize = minefield_finalize;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_type_class_add_private (klass, sizeof (MinefieldPrivate));
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("clock_started", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("paused_changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("tick", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("redraw_sector", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("marks_changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("explode", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_signal_new ("cleared", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2599 "minefield.c"
}


static void minefield_instance_init (Minefield * self) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv = MINEFIELD_GET_PRIVATE (self);
#line 51 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->width = (guint) 0;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->height = (guint) 0;
#line 55 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->n_mines = (guint) 0;
#line 61 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->exploded = FALSE;
#line 64 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->placed_mines = FALSE;
#line 67 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->_n_cleared = (guint) 0;
#line 68 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->_n_flags = (guint) 0;
#line 102 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->_paused = FALSE;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->ref_count = 1;
#line 2624 "minefield.c"
}


static void minefield_finalize (Minefield* obj) {
	Minefield * self;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINEFIELD, Minefield);
#line 58 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	self->priv->locations = (_vala_array_free (self->priv->locations, self->priv->locations_length1 * self->priv->locations_length2, (GDestroyNotify) location_unref), NULL);
#line 89 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 2636 "minefield.c"
}


GType minefield_get_type (void) {
	static volatile gsize minefield_type_id__volatile = 0;
	if (g_once_init_enter (&minefield_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_minefield_init, value_minefield_free_value, value_minefield_copy_value, value_minefield_peek_pointer, "p", value_minefield_collect_value, "p", value_minefield_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (MinefieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) minefield_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Minefield), 0, (GInstanceInitFunc) minefield_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType minefield_type_id;
		minefield_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Minefield", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&minefield_type_id__volatile, minefield_type_id);
	}
	return minefield_type_id__volatile;
}


gpointer minefield_ref (gpointer instance) {
	Minefield* self;
	self = instance;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	g_atomic_int_inc (&self->ref_count);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	return instance;
#line 2661 "minefield.c"
}


void minefield_unref (gpointer instance) {
	Minefield* self;
	self = instance;
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		MINEFIELD_GET_CLASS (self)->finalize (self);
#line 48 "/home/mcatanzaro/jhbuild/src/gnome-mines/src/minefield.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2674 "minefield.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



